within ;
model MyFirstFMU " This model simulates the exponential decay curve"
  Real x(start = 1.0) "continuous state variable";
  Modelica.Blocks.Interfaces.RealInput u "input variable"
    annotation (Placement(transformation(extent={{-140,-20},{-100,20}})));
  Modelica.Blocks.Interfaces.RealOutput y "output variable"
    annotation (Placement(transformation(extent={{100,-10},{120,10}})));
equation
    der(x) = u - x;
    y = -x;
    annotation ( Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,
            -100},{100,100}}),
                      graphics={Rectangle(extent={{-100,100},{100,-100}},
            lineColor={0,0,255}),
        Text(
          extent={{-30,24},{22,-22}},
          lineColor={0,0,127},
          textString="myFirstFMU")}),
           Documentation(info="<html>
           Model that simulates the exponential decay curve.
           The model equations are
<p align=\"left\" style=\"font-style:italic;\">
der (x) = u-x with x(0)=1.0 and y = -x.
</p>
<p>
</html>", revisions="<html>
<ul>
<li>
June 22 2015, by Thierry S. Nouidui:<br/>
First implementation.
</li>
</ul>
</html>"),
    Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
            100,100}}), graphics={
        Text(
          extent={{-24,24},{28,-22}},
          lineColor={0,0,127},
          textString="myFirstFMU")}));
  annotation (uses(Modelica(version="3.2.1")));
end MyFirstFMU;
